const EXPORTED_SYMBOLS = ["util", "HttpContext"];

const Cc = Components.classes;
const Ci = Components.interfaces;

const util = {
  log: function(msg) {//status stat
    var now = new Date();
    var p = "twitter@" + now.toLocaleTimeString() + '>';
    dump('\n------------------------------------------------------------------\n' + p + msg);
    Cc["@mozilla.org/consoleservice;1"]
      .getService(Ci.nsIConsoleService)
      .logStringMessage(p + msg);
  },

  getText: function(msg) {
    var len = arguments.length - 1;
    var args = new Array(len);
    for (var idx = 0; idx < len; idx++) {
      args[idx] = arguments[idx + 1];
    }
    return Cc["@mozilla.org/intl/stringbundle;1"]
            .getService(Ci.nsIStringBundleService)
            .createBundle("chrome://twitter-extension/locale/general.properties")
            .formatStringFromName(msg, args, args.length);
  },

  setHttpObservers: {
    _observers: null,

    get isActive() {
      return this._observers !== null;
    },

    enable: function(onResponse) {
      if (this._observers !== null) {
        throw "connections.enable ==> this._observers=true";
      }
      this._observers = [onResponse];

      util.log('connections on');
      var obs = Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);
      obs.addObserver(this._observers[0], "http-on-examine-response", false);
    },

    disable: function() {
      util.log("connections off");
      var obs = Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);
      obs.removeObserver(this._observers[0], "http-on-examine-response");
      this._observers = null;
    }
  }

};



var HttpContext = {
  findWindow: function(request) {
    var context = this._loadContext(request);
    if (context) {
      if (!context.isContent) {
        util.log('CONTEXT=CHROME => ' + request.URI.spec);
      }
      return context.isContent ? context.associatedWindow : null;
    }

    // nsILoadContext doesn't work with CSS (background image)
    var progress = this._webProgress(request);
    if (progress) {
      var isChrome = progress.DOMWindow instanceof Ci.nsIDOMChromeWindow;
      return isChrome ? null : progress.DOMWindow;
    }

    util.log('CONTEXT FAIL => ' + request.URI.spec);
    return null;
  },

  _loadContext: function(request) {
    try {
      return request
              .queryInterface(Ci.nsIChannel)
              .notificationCallbacks
              .getInterface(Ci.nsILoadContext);
    } catch (ex) {}

    try {
      return request
              .loadGroup
              .notificationCallbacks
              .getInterface(Ci.nsILoadContext);
    } catch (ex) {}

    return null;
  },

  _webProgress: function(request) {
    if (request.notificationCallbacks) {
      try {
        return request
                .notificationCallbacks
                .getInterface(Ci.nsIWebProgress);
      } catch (ex) {}
    }

    try {
      if (request.loadGroup && request.loadGroup.groupObserver) {
        return request
                .loadGroup
                .groupObserver
                .QueryInterface(Ci.nsIWebProgress);
      }
    } catch (ex) {}

    return null;
  }
};
